#include <SdFat.h>
#include <WaveFile.h>
#ifdef SD_FAT_VERSION
bool writeWaveHeader(SdBaseFile* file, uint32_t rate) {
  WaveHeader header;
  // RIFF chunck
  strncpy_P(header.riff, PSTR("RIFF"), 4);
  header.riffSize = file->fileSize() - 8;
  strncpy_P(header.riffType, PSTR("WAVE"), 4);
  // fmt chunck
  strncpy_P(header.fmt, PSTR("fmt "), 4);
  header.fmtSize = 16;
  header.audioFormat = WAVE_FORMAT_PCM;
  header.nChannel = 1;
  header.sampleRate = rate;
  header.byteRate = 2*rate;
  header.blockAlign = 2;
  header.bitsPerSample = 16;
  // data chunck
  strncpy_P(header.data, PSTR("data"), 4);
  header.dataSize = file->fileSize() - sizeof(WaveHeader);
  file->rewind();
  if (sizeof(header) != file->write(&header, sizeof(header))) {
    return false;
    }
  return file->sync();
}
#endif  // SD_FAT_VERSION